"use strict";

const resolvableExtensions = () => [`.ts`, `.tsx`];

function onCreateBabelConfig({
  actions
}, options) {
  actions.setBabelPreset({
    name: require.resolve(`@babel/preset-typescript`),
    options
  });
  actions.setBabelPlugin({
    name: require.resolve(`@babel/plugin-proposal-optional-chaining`)
  });
  actions.setBabelPlugin({
    name: require.resolve(`@babel/plugin-proposal-nullish-coalescing-operator`)
  });
  actions.setBabelPlugin({
    name: require.resolve(`@babel/plugin-proposal-numeric-separator`)
  });
}

function onCreateWebpackConfig({
  actions,
  loaders
}) {
  const jsLoader = loaders.js();

  if (!jsLoader) {
    return;
  }

  actions.setWebpackConfig({
    module: {
      rules: [{
        test: /\.tsx?$/,
        use: jsLoader
      }]
    }
  });
}

exports.resolvableExtensions = resolvableExtensions;
exports.onCreateBabelConfig = onCreateBabelConfig;
exports.onCreateWebpackConfig = onCreateWebpackConfig;